<?php
	/*
	 *	Copyright 2007 John Oren
	 *	
	 *	Licensed under the Apache License, Version 2.0 (the "License");
	 *	you may not use this file except in compliance with the License.
	 *	You may obtain a copy of the License at
	 *		http://www.apache.org/licenses/LICENSE-2.0
	 *	Unless required by applicable law or agreed to in writing, software
	 *	distributed under the License is distributed on an "AS IS" BASIS,
	 *	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 *	See the License for the specific language governing permissions and
	 *	limitations under the License.
	 */
	
	
	session_start();
	//Start output buffering for servers that do not natively support it.
	//This buffering is terminated at the very end of every page.
	ob_start();
	
	//define site name constant (for creating and destroying cookies)
	define("SITE_NAME", "");
	//define site database constants
	if($_SERVER["HTTP_HOST"] == "www.".SITE_NAME || $_SERVER["HTTP_HOST"] == SITE_NAME) { //live
		define("DB_USER", "");
		define("DB_PASS", "");
		define("DB_ROOT", "");
		define("DB_NAME", "");
	} else { //dev
		define("DB_USER", "");
		define("DB_PASS", "");
		define("DB_ROOT", "");
		define("DB_NAME", "");
	}
	
	//useful debug function
	function dump($name, $array) {
		if(!is_array($array)) {
			print "\$".$name." = ".$array."<br>";
			return;
		}
		foreach($array as $key=>$val) {
			if(is_array($val)) {
				dump($name."[".$key."]", $val);
			} else {
				print $name."[".$key."] = ".$val."<br>";
			}
		}
	}
?>