<?php
	/*
	 *	Copyright 2007 John Oren
	 *	
	 *	Licensed under the Apache License, Version 2.0 (the "License");
	 *	you may not use this file except in compliance with the License.
	 *	You may obtain a copy of the License at
	 *		http://www.apache.org/licenses/LICENSE-2.0
	 *	Unless required by applicable law or agreed to in writing, software
	 *	distributed under the License is distributed on an "AS IS" BASIS,
	 *	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 *	See the License for the specific language governing permissions and
	 *	limitations under the License.
	 */
	
	
	require_once($path."OpenSiteAdmin/include.php");
	require_once($path."OpenSiteAdmin/scripts/classes/ErrorLogManager.php");
	
	/**
	 * Interfaces with the site database.
	 * 
	 * Provides an interface to connect to an interact with the database generally.
	 * 
	 * @author John Oren
	 * @version 1.0 December 30, 2007
	 */
	class DatabaseManager {
		/** @var The name of the server this database manager is currently connected to. */
		private $server;
		/** @var The username used to establish the current database connection. */
		private $username;
		/** @var The link resource referring to the currently active database connection. */
		private $SQL;
		/** @var The name of the database this database manager is currently connected to. */
		private $database;
		
		/**
		 * Constructs a database manager with a link resource to a MySQL database.
		 * 
		 * @param STRING $user The username to use when connecting to the database.
		 * @param STRING $pass The password to use for the given username.
		 * @param STRING $db The name of the database to connect to.
		 * @param STRING $host The name of the server to connect to.
		 */
		function __construct($user=DB_USER, $pass=DB_PASS, $db=DB_NAME, $host=DB_ROOT) {
			$this->SQL = mysql_connect($host, $user, $pass) or die('Could not login: ' . mysql_error());
			$this->username = $user;
			$this->server = $host;
			if($db != null) {
				mysql_select_db($db) or die('Couldn\'t connect to '.$db.'-'.mysql_error());
				$this->database = $db;
			} else {
				$this->database = null;
			}
		}
		
		/**
		 * Sets the database this database manager is currently connected to.
		 * 
		 * @param STRING $db The name of the database to connect to.
		 * @return VOID
		 */
		function selectDatabase($db) {
			mysql_select_db($db) or die('Couldn\'t connect to '.$db.'-'.mysql_error());
			$this->database = $db;
		}
		
		/**
		 * Attempts to change the user used to connect to the database.
		 * 
		 * @param STRING $db The name of the database to connect to.
		 * @param STRING $db The name of the database to connect to.
		 * @return BOOLEAN True if the new username and password were valid and 
		 *				   the connection could be established to the current database.
		 */
		function changeUser($user, $pass) {
			$this->SQL = mysql_connect($this->server, $this->user, $this->pass);
			if($this->SQL === false) {
				return false;
			}
			$this->username = $user;
			if($this->database != null) {
				$temp = mysql_select_db($this->database);
				if($temp === false) {
					return false;
				}
			}
			return true;
		}
		
		/**
		 * Returns the link resource to the database this class is managing.
		 * 
		 * @return RESOURCE Link reource to the database.
		 */
		function getLinkResource() {
			return $this->SQL;
		}
		
		/**
		 * Returns the name of the user currently logged into the database.
		 * 
		 * @return STRING Currently active user name.
		 */
		function getUser() {
			return $this->username;
		}
		
		/**
		 * Returns the name of the server this class is currently connected to.
		 * 
		 * @return STRING Name of the server this class is currently connected to.
		 */
		function getServer() {
			return $this->server;
		}
		
		/**
		 * Returns the name of the database this manager is currently connected to.
		 * 
		 * @return STRING Currently used database name.
		 */
		function getDatabase() {
			return $this->database;
		}
	}
?>